=== modified file 'drizzled/opt_range.cc'
--- drizzled/opt_range.cc	2008-12-10 07:43:50 +0000
+++ drizzled/opt_range.cc	2008-12-19 21:20:43 +0000
@@ -1017,11 +1017,11 @@
   *error=0;
 
   if (!conds && !allow_null_cond)
-    return(0);
+    return 0;
   if (!(select= new SQL_SELECT))
   {
     *error= 1;			// out of memory
-    return(0);		/* purecov: inspected */
+    return 0;		/* purecov: inspected */
   }
   select->read_tables=read_tables;
   select->const_tables=const_tables;
@@ -1190,7 +1190,7 @@
 
 int QUICK_INDEX_MERGE_SELECT::init()
 {
-  return(0);
+  return 0;
 }
 
 int QUICK_INDEX_MERGE_SELECT::reset()
@@ -1295,7 +1295,7 @@
   {
     if (init() || reset())
     {
-      return(1);
+      return 0;
     }
     head->column_bitmaps_set(&column_bitmap, &column_bitmap);
     goto end;
@@ -1305,7 +1305,7 @@
   if (free_file)
   {
     /* already have own 'handler' object. */
-    return(0);
+    return 0;
   }
 
   session= head->in_use;
@@ -1357,13 +1357,13 @@
   bitmap_copy(&column_bitmap, head->read_set);
   head->column_bitmaps_set(&column_bitmap, &column_bitmap);
 
-  return(0);
+  return 0;
 
 failure:
   head->column_bitmaps_set(save_read_set, save_write_set);
   delete file;
   file= save_file;
-  return(1);
+  return 0;
 }
 
 
@@ -1398,13 +1398,13 @@
       selects.
     */
     if (quick->init_ror_merged_scan(true))
-      return(1);
+      return 0;
     quick->file->extra(HA_EXTRA_KEYREAD_PRESERVE_FIELDS);
   }
   while ((quick= quick_it++))
   {
     if (quick->init_ror_merged_scan(false))
-      return(1);
+      return 0;
     quick->file->extra(HA_EXTRA_KEYREAD_PRESERVE_FIELDS);
     /* All merged scans share the same record buffer in intersection. */
     quick->record= head->record[0];
@@ -1412,9 +1412,9 @@
 
   if (need_to_fetch_row && head->file->ha_rnd_init(1))
   {
-    return(1);
+    return 0;
   }
-  return(0);
+  return 0;
 }
 
 
@@ -1430,13 +1430,13 @@
 int QUICK_ROR_INTERSECT_SELECT::reset()
 {
   if (!scans_inited && init_ror_merged_scan(true))
-    return(1);
+    return 0;
   scans_inited= true;
   List_iterator_fast<QUICK_RANGE_SELECT> it(quick_selects);
   QUICK_RANGE_SELECT *quick;
   while ((quick= it++))
     quick->reset();
-  return(0);
+  return 0;
 }
 
 
@@ -1502,13 +1502,13 @@
                  (void*) this))
   {
     memset(&queue, 0, sizeof(QUEUE));
-    return(1);
+    return 0;
   }
 
   if (!(cur_rowid= (unsigned char*) alloc_root(&alloc, 2*head->file->ref_length)))
-    return(1);
+    return 0;
   prev_rowid= cur_rowid + head->file->ref_length;
-  return(0);
+  return 0;
 }
 
 
@@ -1552,7 +1552,7 @@
     while ((quick= it++))
     {
       if (quick->init_ror_merged_scan(false))
-        return(1);
+        return 0;
     }
     scans_inited= true;
   }
@@ -1565,7 +1565,7 @@
   while ((quick= it++))
   {
     if (quick->reset())
-      return(1);
+      return 0;
     if ((error= quick->get_next()))
     {
       if (error == HA_ERR_END_OF_FILE)
@@ -1578,10 +1578,10 @@
 
   if (head->file->ha_rnd_init(1))
   {
-    return(1);
+    return 0;
   }
 
-  return(0);
+  return 0;
 }
 
 
@@ -1954,7 +1954,7 @@
       quick->records= records;
       quick->read_time= read_cost;
     }
-    return(quick);
+    return quick;
   }
 };
 
@@ -2184,7 +2184,7 @@
   needed_reg.clear_all();
   quick_keys.clear_all();
   if (keys_to_use.is_clear_all())
-    return(0);
+    return 0;
   records= head->file->stats.records;
   if (!records)
     records++;					/* purecov: inspected */
@@ -2195,7 +2195,7 @@
   if (limit < records)
     read_time= (double) records + scan_time + 1; // Force to use index
   else if (read_time <= 2.0 && !force_quick_range)
-    return(0);				/* No need for quick select */
+    return 0;				/* No need for quick select */
 
   keys_to_use.intersect(head->keys_in_use_for_query);
   if (!keys_to_use.is_clear_all())
@@ -2207,7 +2207,7 @@
     PARAM param;
 
     if (check_stack_overrun(session, 2*STACK_MIN_SIZE, NULL))
-      return(0);                           // Fatal error flag is set
+      return 0;                           // Fatal error flag is set
 
     /* set up parameter that is passed to all functions */
     param.session= session;
@@ -2234,7 +2234,7 @@
     {
       session->no_errors=0;
       free_root(&alloc,MYF(0));			// Return memory & allocator
-      return(0);				// Can't use range
+      return 0;				// Can't use range
     }
     key_parts= param.key_parts;
     session->mem_root= &alloc;
@@ -2507,7 +2507,7 @@
   if (!(range_scans= (TRP_RANGE**)alloc_root(param->mem_root,
                                              sizeof(TRP_RANGE*)*
                                              n_child_scans)))
-    return(NULL);
+    return NULL;
   /*
     Collect best 'range' scan for each of disjuncts, and, while doing so,
     analyze possibility of ROR scans. Also calculate some values needed by
@@ -2552,7 +2552,7 @@
       Bail out if it is obvious that both index_merge and ROR-union will be
       more expensive
     */
-    return(NULL);
+    return NULL;
   }
   if (all_scans_rors)
   {
@@ -2589,7 +2589,7 @@
   {
     if (!(param->imerge_cost_buff= (uint*)alloc_root(param->mem_root,
                                                      unique_calc_buff_size)))
-      return(NULL);
+      return NULL;
     param->imerge_cost_buff_size= unique_calc_buff_size;
   }
 
@@ -2761,7 +2761,7 @@
 
   if (!(ror_scan= (ROR_SCAN_INFO*)alloc_root(param->mem_root,
                                              sizeof(ROR_SCAN_INFO))))
-    return(NULL);
+    return NULL;
 
   ror_scan->idx= idx;
   ror_scan->keynr= keynr= param->real_keynr[idx];
@@ -2772,11 +2772,11 @@
 
   if (!(bitmap_buf= (my_bitmap_map*) alloc_root(param->mem_root,
                                                 param->fields_bitmap_size)))
-    return(NULL);
+    return NULL;
 
   if (bitmap_init(&ror_scan->covered_fields, bitmap_buf,
                   param->table->s->fields, false))
-    return(NULL);
+    return NULL;
   bitmap_clear_all(&ror_scan->covered_fields);
 
   KEY_PART_INFO *key_part= param->table->key_info[keynr].key_part;
@@ -3124,7 +3124,7 @@
   if (selectivity_mult == 1.0)
   {
     /* Don't add this scan if it doesn't improve selectivity. */
-    return(false);
+    return false;
   }
 
   info->out_rows *= selectivity_mult;
@@ -3161,7 +3161,7 @@
                         is_interrupted, &sweep_cost);
     info->total_cost += sweep_cost.total_cost();
   }
-  return(true);
+  return true;
 }
 
 
@@ -3238,7 +3238,7 @@
   double min_cost= DBL_MAX;
 
   if ((tree->n_ror_scans < 2) || !param->table->file->stats.records)
-    return(NULL);
+    return NULL;
 
   /*
     Step1: Collect ROR-able SEL_ARGs and create ROR_SCAN_INFO for each of
@@ -3327,7 +3327,7 @@
 
   if (intersect_scans_best == intersect_scans)
   {
-    return(NULL);
+    return NULL;
   }
 
   print_ror_scans_arr(param->table,
@@ -3363,7 +3363,7 @@
     if (!(trp->first_scan=
            (ROR_SCAN_INFO**)alloc_root(param->mem_root,
                                        sizeof(ROR_SCAN_INFO*)*best_num)))
-      return(NULL);
+      return NULL;
     memcpy(trp->first_scan, intersect_scans, best_num*sizeof(ROR_SCAN_INFO*));
     trp->last_scan=  trp->first_scan + best_num;
     trp->is_covering= intersect_best->is_covering;
@@ -3441,7 +3441,7 @@
   if (!covered_fields->bitmap ||
       bitmap_init(covered_fields, covered_fields->bitmap,
                   param->table->s->fields, false))
-    return(0);
+    return 0;
   bitmap_clear_all(covered_fields);
 
   double total_cost= 0.0f;
@@ -3479,14 +3479,14 @@
     total_cost += (*ror_scan_mark)->index_read_cost;
     records += (*ror_scan_mark)->records;
     if (total_cost > read_time)
-      return(NULL);
+      return NULL;
     /* F=F-covered by first(I) */
     bitmap_union(covered_fields, &(*ror_scan_mark)->covered_fields);
     all_covered= bitmap_is_subset(&param->needed_fields, covered_fields);
   } while ((++ror_scan_mark < ror_scans_end) && !all_covered);
 
   if (!all_covered || (ror_scan_mark - tree->ror_scans) == 1)
-    return(NULL);
+    return NULL;
 
   /*
     Ok, [tree->ror_scans .. ror_scan) holds covering index_intersection with
@@ -3502,7 +3502,7 @@
                 (TIME_FOR_COMPARE_ROWID * M_LN2);
 
   if (total_cost > read_time)
-    return(NULL);
+    return NULL;
 
   TRP_ROR_INTERSECT *trp;
   if (!(trp= new (param->mem_root) TRP_ROR_INTERSECT))
@@ -3511,7 +3511,7 @@
   if (!(trp->first_scan= (ROR_SCAN_INFO**)alloc_root(param->mem_root,
                                                      sizeof(ROR_SCAN_INFO*)*
                                                      best_num)))
-    return(NULL);
+    return NULL;
   memcpy(trp->first_scan, tree->ror_scans, best_num*sizeof(ROR_SCAN_INFO*));
   trp->last_scan=  trp->first_scan + best_num;
   trp->is_covering= true;
@@ -3674,7 +3674,7 @@
           quick_intrsect->push_quick_back(quick))
       {
         delete quick_intrsect;
-        return(NULL);
+        return NULL;
       }
     }
     if (cpk_scan)
@@ -3685,7 +3685,7 @@
                                     0, alloc)))
       {
         delete quick_intrsect;
-        return(NULL);
+        return NULL;
       }
       quick->file= NULL;
       quick_intrsect->cpk_quick= quick;
@@ -3712,7 +3712,7 @@
     {
       if (!(quick= (*scan)->make_quick(param, false, &quick_roru->alloc)) ||
           quick_roru->push_quick_back(quick))
-        return(NULL);
+        return NULL;
     }
     quick_roru->records= records;
     quick_roru->read_time= read_cost;
@@ -4130,7 +4130,7 @@
 	SEL_TREE *new_tree=get_mm_tree(param,item);
 	if (param->session->is_fatal_error ||
             param->alloced_sel_args > SEL_ARG::MAX_SEL_ARGS)
-	  return(0);	// out of memory
+	  return 0;	// out of memory
 	tree=tree_and(param,tree,new_tree);
 	if (tree && tree->type == SEL_TREE::IMPOSSIBLE)
 	  break;
@@ -4146,7 +4146,7 @@
 	{
 	  SEL_TREE *new_tree=get_mm_tree(param,item);
 	  if (!new_tree)
-	    return(0);	// out of memory
+	    return 0;	// out of memory
 	  tree=tree_or(param,tree,new_tree);
 	  if (!tree || tree->type == SEL_TREE::ALWAYS)
 	    break;
@@ -4180,7 +4180,7 @@
     ref_tables= cond->used_tables();
     if ((ref_tables & param->current_table) ||
 	(ref_tables & ~(param->prev_tables | param->read_tables)))
-      return(0);
+      return 0;
     return(new SEL_TREE(SEL_TREE::MAYBE));
   }
 
@@ -4189,7 +4189,7 @@
       cond_func->functype() == Item_func::IN_FUNC)
     inv= ((Item_func_opt_neg *) cond_func)->negated;
   else if (cond_func->select_optimize() == Item_func::OPTIMIZE_NONE)
-    return(0);
+    return 0;
 
   param->cond= cond;
 
@@ -4230,7 +4230,7 @@
   {
     Item_func_in *func=(Item_func_in*) cond_func;
     if (func->key_item()->real_item()->type() != Item::FIELD_ITEM)
-      return(0);
+      return 0;
     field_item= (Item_field*) (func->key_item()->real_item());
     ftree= get_full_func_mm_tree(param, cond_func, field_item, NULL, inv);
     break;
@@ -4239,7 +4239,7 @@
   {
     Item_equal *item_equal= (Item_equal *) cond;
     if (!(value= item_equal->get_const()))
-      return(0);
+      return 0;
     Item_equal_iterator it(*item_equal);
     ref_tables= value->used_tables();
     while ((field_item= it++))
@@ -4270,7 +4270,7 @@
       value= cond_func->arguments()[0];
     }
     else
-      return(0);
+      return 0;
     ftree= get_full_func_mm_tree(param, cond_func, field_item, value, inv);
   }
 
@@ -4284,21 +4284,21 @@
 	     Item *value, Item_result)
 {
   if (field->table != param->table)
-    return(0);
+    return 0;
 
   KEY_PART *key_part = param->key_parts;
   KEY_PART *end = param->key_parts_end;
   SEL_TREE *tree=0;
   if (value &&
       value->used_tables() & ~(param->prev_tables | param->read_tables))
-    return(0);
+    return 0;
   for (; key_part != end ; key_part++)
   {
     if (field->eq(key_part->field))
     {
       SEL_ARG *sel_arg=0;
       if (!tree && !(tree=new SEL_TREE()))
-	return(0);				// OOM
+	return 0;				// OOM
       if (!value || !(value->used_tables() & ~param->read_tables))
       {
 	sel_arg=get_mm_leaf(param,cond_func,
@@ -4315,7 +4315,7 @@
       {
 	// This key may be used later
 	if (!(sel_arg= new SEL_ARG(SEL_ARG::MAYBE_KEY)))
-	  return(0);			// OOM
+	  return 0;			// OOM
       }
       sel_arg->part=(unsigned char) key_part->part;
       tree->keys[key_part->key]=sel_add(tree->keys[key_part->key],sel_arg);
@@ -4767,7 +4767,7 @@
   common_keys.intersect(tree2->keys_map);
 
   if (common_keys.is_clear_all())
-    return(false);
+    return false;
 
   /* trees have a common key, check if they refer to same key part */
   SEL_ARG **key1,**key2;
@@ -4779,11 +4779,11 @@
       key2= tree2->keys + key_no;
       if ((*key1)->part == (*key2)->part)
       {
-        return(true);
+        return true;
       }
     }
   }
-  return(false);
+  return false;
 }
 
 
@@ -4866,7 +4866,7 @@
 tree_or(RANGE_OPT_PARAM *param,SEL_TREE *tree1,SEL_TREE *tree2)
 {
   if (!tree1 || !tree2)
-    return(0);
+    return 0;
   if (tree1->type == SEL_TREE::IMPOSSIBLE || tree2->type == SEL_TREE::ALWAYS)
     return(tree2);
   if (tree2->type == SEL_TREE::IMPOSSIBLE || tree1->type == SEL_TREE::ALWAYS)
@@ -4944,7 +4944,7 @@
         result= tree1;
     }
   }
-  return(result);
+  return result;
 }
 
 
@@ -5555,7 +5555,7 @@
   }
 
   if (root == &null_element)
-    return(0);				// Maybe root later
+    return 0;				// Maybe root later
   if (remove_color == BLACK)
     root=rb_delete_fixup(root,nod,fix_par);
 #ifdef EXTRA_DEBUG
@@ -6393,7 +6393,7 @@
                     param->table->key_info[param->real_keynr[idx]].key_parts);
     }
   }
-  return(quick);
+  return quick;
 }
 
 
@@ -6755,13 +6755,13 @@
     reset here.
   */
   if (cur_quick->init() || cur_quick->reset())
-    return(1);
+    return 0;
 
   unique= new Unique(refpos_order_cmp, (void *)file,
                      file->ref_length,
                      session->variables.sortbuff_size);
   if (!unique)
-    return(1);
+    return 0;
   for (;;)
   {
     while ((result= cur_quick->get_next()) == HA_ERR_END_OF_FILE)
@@ -6774,7 +6774,7 @@
       if (cur_quick->file->inited != handler::NONE)
         cur_quick->file->ha_index_end();
       if (cur_quick->init() || cur_quick->reset())
-        return(1);
+        return 0;
     }
 
     if (result)
@@ -6782,13 +6782,13 @@
       if (result != HA_ERR_END_OF_FILE)
       {
         cur_quick->range_end();
-        return(result);
+        return result;
       }
       break;
     }
 
     if (session->killed)
-      return(1);
+      return 0;
 
     /* skip row if it will be retrieved by clustered PK scan */
     if (pk_quick_select && pk_quick_select->row_in_ranges())
@@ -6797,7 +6797,7 @@
     cur_quick->file->position(cur_quick->record);
     result= unique->unique_add((char*)cur_quick->file->ref);
     if (result)
-      return(1);
+      return 0;
 
   }
 
@@ -6809,7 +6809,7 @@
   file->extra(HA_EXTRA_NO_KEYREAD);
   /* start table scan */
   init_read_record(&read_record, session, head, (SQL_SELECT*) 0, 1, 1);
-  return(result);
+  return result;
 }
 
 
@@ -6839,12 +6839,12 @@
       doing_pk_scan= true;
       if ((result= pk_quick_select->init()) ||
           (result= pk_quick_select->reset()))
-        return(result);
+        return result;
       return(pk_quick_select->get_next());
     }
   }
 
-  return(result);
+  return result;
 }
 
 
@@ -7211,7 +7211,7 @@
     /* Restore bitmaps set on entry */
     head->column_bitmaps_set_no_signal(save_read_set, save_write_set);
   }
-  return(result);
+  return result;
 }
 
 
@@ -7258,7 +7258,7 @@
       result= file->index_read_map(record, cur_prefix, keypart_map,
                                    HA_READ_AFTER_KEY);
       if (result || (file->compare_key(file->end_range) <= 0))
-        return(result);
+        return result;
     }
 
     uint32_t count= ranges.elements - (cur_range - (QUICK_RANGE**) ranges.buffer);
@@ -7266,7 +7266,7 @@
     {
       /* Ranges have already been used up before. None is left for read. */
       last_range= 0;
-      return(HA_ERR_END_OF_FILE);
+      return HA_ERR_END_OF_FILE;
     }
     last_range= *(cur_range++);
 
@@ -7294,7 +7294,7 @@
       last_range= 0;			// Stop searching
 
     if (result != HA_ERR_END_OF_FILE)
-      return(result);
+      return result;
     last_range= 0;			// No matching rows; go to next range
   }
 }
@@ -7398,14 +7398,14 @@
       if (!result)
       {
 	if (cmp_prev(*rev_it.ref()) == 0)
-	  return(0);
+	  return 0;
       }
       else if (result != HA_ERR_END_OF_FILE)
-	return(result);
+	return result;
     }
 
     if (!(last_range= rev_it++))
-      return(HA_ERR_END_OF_FILE);		// All ranges used
+      return HA_ERR_END_OF_FILE;		// All ranges used
 
     if (last_range->flag & NO_MAX_RANGE)        // Read last record
     {
@@ -7413,7 +7413,7 @@
       if ((local_error=file->index_last(record)))
 	return(local_error);		// Empty table
       if (cmp_prev(last_range) == 0)
-	return(0);
+	return 0;
       last_range= 0;                            // No match; go to next range
       continue;
     }
@@ -7437,7 +7437,7 @@
     if (result)
     {
       if (result != HA_ERR_KEY_NOT_FOUND && result != HA_ERR_END_OF_FILE)
-	return(result);
+	return result;
       last_range= 0;                            // Not found, to next range
       continue;
     }
@@ -7445,7 +7445,7 @@
     {
       if (last_range->flag == (UNIQUE_RANGE | EQ_RANGE))
 	last_range= 0;				// Stop searching
-      return(0);				// Found key is in range
+      return 0;				// Found key is in range
     }
     last_range= 0;                              // To next range
   }
@@ -7873,21 +7873,21 @@
 
   /* Perform few 'cheap' tests whether this access method is applicable. */
   if (!join)
-    return(NULL);        /* This is not a select statement. */
+    return NULL;        /* This is not a select statement. */
   if ((join->tables != 1) ||  /* The query must reference one table. */
       ((!join->group_list) && /* Neither GROUP BY nor a DISTINCT query. */
        (!join->select_distinct)) ||
       (join->select_lex->olap == ROLLUP_TYPE)) /* Check (B3) for ROLLUP */
-    return(NULL);
+    return NULL;
   if (table->s->keys == 0)        /* There are no indexes to use. */
-    return(NULL);
+    return NULL;
 
   /* Analyze the query in more detail. */
   List_iterator<Item> select_items_it(join->fields_list);
 
   /* Check (SA1,SA4) and store the only MIN/MAX argument - the C attribute.*/
   if (join->make_sum_func_list(join->all_fields, join->fields_list, 1))
-    return(NULL);
+    return NULL;
   if (join->sum_funcs[0])
   {
     Item_sum *min_max_item;
@@ -7899,7 +7899,7 @@
       else if (min_max_item->sum_func() == Item_sum::MAX_FUNC)
         have_max= true;
       else
-        return(NULL);
+        return NULL;
 
       /* The argument of MIN/MAX. */
       Item *expr= min_max_item->args[0]->real_item();
@@ -7908,10 +7908,10 @@
         if (! min_max_arg_item)
           min_max_arg_item= (Item_field*) expr;
         else if (! min_max_arg_item->eq(expr, 1))
-          return(NULL);
+          return NULL;
       }
       else
-        return(NULL);
+        return NULL;
     }
   }
 
@@ -7921,7 +7921,7 @@
     while ((item= select_items_it++))
     {
       if (item->type() != Item::FIELD_ITEM)
-        return(NULL);
+        return NULL;
     }
   }
 
@@ -7929,7 +7929,7 @@
   for (tmp_group= join->group_list; tmp_group; tmp_group= tmp_group->next)
   {
     if ((*tmp_group->item)->type() != Item::FIELD_ITEM)
-      return(NULL);
+      return NULL;
   }
 
   /*
@@ -8215,12 +8215,12 @@
     cur_group_prefix_len= 0;
   }
   if (!index_info) /* No usable index found. */
-    return(NULL);
+    return NULL;
 
   /* Check (SA3) for the where clause. */
   if (join->conds && min_max_arg_item &&
       !check_group_min_max_predicates(join->conds, min_max_arg_item, Field::itRAW))
-    return(NULL);
+    return NULL;
 
   /* The query passes all tests, so construct a new TRP object. */
   read_plan= new (param->mem_root)
@@ -8234,13 +8234,13 @@
   if (read_plan)
   {
     if (tree && read_plan->quick_prefix_records == 0)
-      return(NULL);
+      return NULL;
 
     read_plan->read_cost= best_read_cost;
     read_plan->records=   best_records;
   }
 
-  return(read_plan);
+  return read_plan;
 }
 
 
@@ -8282,9 +8282,9 @@
     {
       if (!check_group_min_max_predicates(and_or_arg, min_max_arg_item,
                                          image_type))
-        return(false);
+        return false;
     }
-    return(true);
+    return true;
   }
 
   /*
@@ -8297,7 +8297,7 @@
     so.
   */
   if (cond_type == Item::SUBSELECT_ITEM)
-    return(false);
+    return false;
 
   /* We presume that at this point there are no other Items than functions. */
   assert(cond_type == Item::FUNC_ITEM);
@@ -8328,7 +8328,7 @@
             pred_type != Item_func::ISNOTNULL_FUNC &&
             pred_type != Item_func::EQ_FUNC        &&
             pred_type != Item_func::NE_FUNC)
-          return(false);
+          return false;
 
         /* Check that pred compares min_max_arg_item with a constant. */
         Item *args[3];
@@ -8336,7 +8336,7 @@
         bool inv;
         /* Test if this is a comparison of a field and a constant. */
         if (!simple_pred(pred, args, &inv))
-          return(false);
+          return false;
 
         /* Check for compatible string comparisons - similar to get_mm_leaf. */
         if (args[0] && args[1] && !args[2] && // this is a binary function
@@ -8355,24 +8355,24 @@
              */
              (args[1]->result_type() != STRING_RESULT &&
               min_max_arg_item->field->cmp_type() != args[1]->result_type())))
-          return(false);
+          return false;
       }
     }
     else if (cur_arg->type() == Item::FUNC_ITEM)
     {
       if (!check_group_min_max_predicates(cur_arg, min_max_arg_item,
                                          image_type))
-        return(false);
+        return false;
     }
     else if (cur_arg->const_item())
     {
-      return(true);
+      return true;
     }
     else
-      return(false);
+      return false;
   }
 
-  return(true);
+  return true;
 }
 
 
@@ -8539,7 +8539,7 @@
     idx++;
   }
   *param_idx= idx;
-  return(range_tree->keys[idx]);
+  return range_tree->keys[idx];
 }
 
 
@@ -8674,7 +8674,6 @@
 
   *read_cost= io_cost + cpu_cost;
   *records= num_groups;
-  return;
 }
 
 
@@ -8712,12 +8711,12 @@
                                         read_cost, records, key_infix_len,
                                         key_infix, parent_alloc);
   if (!quick)
-    return(NULL);
+    return NULL;
 
   if (quick->init())
   {
     delete quick;
-    return(NULL);
+    return NULL;
   }
 
   if (range_tree)
@@ -8756,7 +8755,7 @@
         {
           delete quick;
           quick= NULL;
-          return(NULL);
+          return NULL;
         }
         min_max_range= min_max_range->next;
       }
@@ -8768,7 +8767,7 @@
   quick->update_key_stat();
   quick->adjust_prefix_ranges();
 
-  return(quick);
+  return quick;
 }
 
 
@@ -8945,7 +8944,6 @@
   delete min_functions_it;
   delete max_functions_it;
   delete quick_prefix_select;
-  return;
 }
 
 
@@ -9122,16 +9120,16 @@
 
   file->extra(HA_EXTRA_KEYREAD); /* We need only the key attributes */
   if ((result= file->ha_index_init(index,1)))
-    return(result);
+    return result;
   if (quick_prefix_select && quick_prefix_select->reset())
-    return(1);
+    return 0;
   result= file->index_last(record);
   if (result == HA_ERR_END_OF_FILE)
-    return(0);
+    return 0;
   /* Save the prefix of the last group. */
   key_copy(last_prefix, record, index_info, group_prefix_len);
 
-  return(0);
+  return 0;
 }
 
 
@@ -9208,8 +9206,8 @@
       if (max_res == 0)
         update_max_result();
       /* If a MIN was found, a MAX must have been found as well. */
-      assert((have_max && !have_min) ||
-                  (have_max && have_min && (max_res == 0)));
+      assert(((have_max && !have_min) ||
+                  (have_max && have_min && (max_res == 0))));
     }
     /*
       If this is just a GROUP BY or DISTINCT without MIN or MAX and there
@@ -9238,7 +9236,7 @@
   else if (result == HA_ERR_KEY_NOT_FOUND)
     result= HA_ERR_END_OF_FILE;
 
-  return(result);
+  return result;
 }
 
 
@@ -9273,7 +9271,7 @@
   if (min_max_ranges.elements > 0)
   {
     if ((result= next_min_in_range()))
-      return(result);
+      return result;
   }
   else
   {
@@ -9283,7 +9281,7 @@
       if ((result= file->index_read_map(record, group_prefix,
                                         make_prev_keypart_map(real_key_parts),
                                         HA_READ_KEY_EXACT)))
-        return(result);
+        return result;
     }
 
     /*
@@ -9324,7 +9322,7 @@
     If the MIN attribute is non-nullable, this->record already contains the
     MIN key in the group, so just return.
   */
-  return(result);
+  return result;
 }
 
 
@@ -9355,7 +9353,7 @@
     result= file->index_read_map(record, group_prefix,
                                  make_prev_keypart_map(real_key_parts),
                                  HA_READ_PREFIX_LAST);
-  return(result);
+  return result;
 }
 
 
@@ -9389,7 +9387,7 @@
     unsigned char *cur_prefix= seen_first_key ? group_prefix : NULL;
     if ((result= quick_prefix_select->get_next_prefix(group_prefix_len,
                          make_prev_keypart_map(group_key_parts), cur_prefix)))
-      return(result);
+      return result;
     seen_first_key= true;
   }
   else
@@ -9398,7 +9396,7 @@
     {
       result= file->index_first(record);
       if (result)
-        return(result);
+        return result;
       seen_first_key= true;
     }
     else
@@ -9408,7 +9406,7 @@
                                    make_prev_keypart_map(group_key_parts),
                                    HA_READ_AFTER_KEY);
       if (result)
-        return(result);
+        return result;
     }
   }
 
@@ -9419,7 +9417,7 @@
     memcpy(group_prefix + group_prefix_len,
            key_infix, key_infix_len);
 
-  return(0);
+  return 0;
 }
 
 
@@ -9777,8 +9775,6 @@
   }
   if (!tmp.length())
     tmp.append(STRING_WITH_LEN("(empty)"));
-
-  return;
 }
 
 
@@ -9797,7 +9793,6 @@
   }
   if (!tmp.length())
     tmp.append(STRING_WITH_LEN("(empty)"));
-  return;
 }
 
 /*****************************************************************************

=== removed file 'tests/include/have_community_features.inc'
--- tests/include/have_community_features.inc	2008-06-25 05:29:13 +0000
+++ tests/include/have_community_features.inc	1970-01-01 00:00:00 +0000
@@ -1,4 +0,0 @@
---require r/have_community_features.require
---disable_query_log
-show variables like "have_community_features";
---enable_query_log

=== added file 'tests/r/flush.result'
--- tests/r/flush.result	1970-01-01 00:00:00 +0000
+++ tests/r/flush.result	2008-12-19 22:44:25 +0000
@@ -0,0 +1,52 @@
+drop table if exists t1,t2;
+drop database if exists mysqltest;
+create temporary table t1(n int not null primary key);
+create table t2(n int);
+insert into t2 values(3);
+select * from t1;
+n
+3
+flush tables with read lock;
+drop table t2;
+ERROR HY000: Can't execute the query because you have a conflicting read lock
+drop table t2;
+unlock tables;
+create database mysqltest;
+create table mysqltest.t1(n int);
+insert into mysqltest.t1 values (23);
+flush tables with read lock;
+drop database mysqltest;
+select * from mysqltest.t1;
+n
+23
+unlock tables;
+create table t1 (c1 int);
+lock table t1 write;
+flush tables with read lock;
+ERROR HY000: Can't execute the given command because you have active locked tables or an active transaction
+lock table t1 read;
+flush tables with read lock;
+lock table t1 write;
+ERROR HY000: Can't execute the query because you have a conflicting read lock
+lock table t1 read;
+lock table t1 write;
+ERROR HY000: Can't execute the query because you have a conflicting read lock
+unlock tables;
+create table t2 (c1 int);
+create table t3 (c1 int);
+lock table t1 read, t2 read, t3 write;
+flush tables with read lock;
+ERROR HY000: Can't execute the given command because you have active locked tables or an active transaction
+lock table t1 read, t2 read, t3 read;
+flush tables with read lock;
+unlock tables;
+drop table t1, t2, t3;
+create table t1 (c1 int);
+create table t2 (c1 int);
+lock table t1 write;
+flush tables with read lock;
+insert into t2 values(1);
+unlock tables;
+drop table t1, t2;
+select benchmark(200, (select sin(1))) > 1000;
+End of 5.0 tests

=== renamed file 'tests/suite/broken/r/group_min_max.result' => 'tests/r/group_min_max.result'
--- tests/suite/broken/r/group_min_max.result	2008-06-25 05:29:13 +0000
+++ tests/r/group_min_max.result	2008-12-19 22:00:41 +0000
@@ -1,7 +1,7 @@
 drop table if exists t1;
 create table t1 (
 a1 char(64), a2 char(64), b char(16), c char(16) not null, d char(16), dummy char(64) default ' '
-);
+) ENGINE=MYISAM;
 insert into t1 (a1, a2, b, c, d) values
 ('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
 ('a','a','b','e112','xy1'),('a','a','b','f112','xy2'),('a','a','b','g112','xy3'),('a','a','b','h112','xy4'),
@@ -44,7 +44,7 @@
 drop table if exists t2;
 create table t2 (
 a1 char(64), a2 char(64) not null, b char(16), c char(16), d char(16), dummy char(64) default ' '
-);
+) ENGINE=MYISAM;
 insert into t2 select * from t1;
 insert into t2 (a1, a2, b, c, d) values
 ('a','a',NULL,'a777','xyz'),('a','a',NULL,'a888','xyz'),('a','a',NULL,'a999','xyz'),
@@ -72,7 +72,7 @@
 drop table if exists t3;
 create table t3 (
 a1 char(1), a2 char(1), b char(1), c char(4) not null, d char(3), dummy char(1) default ' '
-);
+) ENGINE=MYISAM;
 insert into t3 (a1, a2, b, c, d) values
 ('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
 ('a','a','b','e112','xy1'),('a','a','b','f112','xy2'),('a','a','b','g112','xy3'),('a','a','b','h112','xy4'),
@@ -133,34 +133,34 @@
 test.t3	analyze	status	Table is already up to date
 explain select a1, min(a2) from t1 group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	130	NULL	5	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	518	NULL	5	Using index for group-by
 explain select a1, max(a2) from t1 group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	65	NULL	5	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	259	NULL	5	Using index for group-by
 explain select a1, min(a2), max(a2) from t1 group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	130	NULL	5	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	518	NULL	5	Using index for group-by
 explain select a1, a2, b, min(c), max(c) from t1 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
 explain select a1,a2,b,max(c),min(c) from t1 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
 explain select a1,a2,b,max(c),min(c) from t2 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	#	NULL	#	Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	#	NULL	#	Using index
 explain select min(a2), a1, max(a2), min(a2), a1 from t1 group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	130	NULL	5	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	518	NULL	5	Using index for group-by
 explain select a1, b, min(c), a1, max(c), b, a2, max(c), max(c) from t1 group by a1, a2, b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
 explain select min(a2) from t1 group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	130	NULL	5	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	518	NULL	5	Using index for group-by
 explain select a2, min(c), max(c) from t1 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
 select a1, min(a2) from t1 group by a1;
 a1	min(a2)
 a	a
@@ -287,73 +287,73 @@
 b	m422	p422
 explain select a1,a2,b,min(c),max(c) from t1 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where a1 >= 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where a1 >= 'c' or a1 < 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1, max(c)            from t1 where a1 >= 'c' or a1 < 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where a1 >= 'c' or a2 < 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where a1 = 'z' or a1 = 'b' or a1 = 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	8	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where a1 = 'z' or a1 = 'b' or a1 = 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	8	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	8	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	8	Using where; Using index for group-by
 explain select a1,min(c),max(c)      from t1 where a1 >= 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,  max(c)           from t1 where a1 in ('a','b','d') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t2 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where a1 >= 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t2 where a1 >= 'c' or a1 < 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select a1, max(c)            from t2 where a1 >= 'c' or a1 < 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where a1 >= 'c' or a2 < 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,       max(c) from t2 where a1 = 'z' or a1 = 'b' or a1 = 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where a1 = 'z' or a1 = 'b' or a1 = 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t2 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,min(c),max(c)      from t2 where a1 >= 'b' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,  max(c)           from t2 where a1 in ('a','b','d') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 select a1,a2,b,min(c),max(c) from t1 where a1 < 'd' group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
 a	a	a	a111	d111
@@ -669,40 +669,40 @@
 d	p422
 explain select a1,a2,b,max(c),min(c) from t1 where (a2 = 'a') and (b = 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	5	Using where; Using index for group-by
 explain select a1,max(c),min(c)      from t1 where (a2 = 'a') and (b = 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	5	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (b = 'b') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	9	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	9	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (b = 'b') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	9	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	9	Using where; Using index for group-by
 explain select a1,a2, max(c)         from t1 where (b = 'b') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	9	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	9	Using where; Using index for group-by
 explain select a1,a2,b,max(c),min(c) from t2 where (a2 = 'a') and (b = 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	5	Using where; Using index for group-by
 explain select a1,max(c),min(c)      from t2 where (a2 = 'a') and (b = 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	5	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t2 where (b = 'b') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	584	NULL	10	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where (b = 'b') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	10	Using where; Using index for group-by
 explain select a1,a2, max(c)         from t2 where (b = 'b') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	584	NULL	10	Using where; Using index for group-by
 explain select a1,a2,b,max(c),min(c) from t3 where (a2 = 'a') and (b = 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t3	range	NULL	idx_t3_1	6	NULL	4	Using where; Using index for group-by
+1	SIMPLE	t3	range	NULL	idx_t3_1	21	NULL	4	Using where; Using index for group-by
 explain select a1,max(c),min(c)      from t3 where (a2 = 'a') and (b = 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t3	range	NULL	idx_t3_1	6	NULL	4	Using where; Using index for group-by
+1	SIMPLE	t3	range	NULL	idx_t3_1	21	NULL	4	Using where; Using index for group-by
 select a1,a2,b,max(c),min(c) from t1 where (a2 = 'a') and (b = 'b') group by a1;
 a1	a2	b	max(c)	min(c)
 a	a	b	h112	e112
@@ -804,22 +804,22 @@
 c	h312	e312
 explain select a1,a2,b,min(c) from t2 where (a2 = 'a') and b is NULL group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	5	Using where; Using index for group-by
 explain select a1,a2,b,max(c) from t2 where (a2 = 'a') and b is NULL group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	584	NULL	5	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t2 where b is NULL group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	10	Using where; Using index for group-by
 explain select a1,a2,b,max(c) from t2 where b is NULL group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	10	Using where; Using index for group-by
-explain select a1,a2,b,min(c),max(c) from t2 where b is NULL group by a1,a2;
-id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	10	Using where; Using index for group-by
-explain select a1,a2,b,min(c),max(c) from t2 where b is NULL group by a1,a2;
-id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t2	range	NULL	idx_t2_1	584	NULL	10	Using where; Using index for group-by
+explain select a1,a2,b,min(c),max(c) from t2 where b is NULL group by a1,a2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	10	Using where; Using index for group-by
+explain select a1,a2,b,min(c),max(c) from t2 where b is NULL group by a1,a2;
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
+1	SIMPLE	t2	range	NULL	idx_t2_1	651	NULL	10	Using where; Using index for group-by
 select a1,a2,b,min(c) from t2 where (a2 = 'a') and b is NULL group by a1;
 a1	a2	b	min(c)
 a	a	NULL	a777
@@ -846,161 +846,101 @@
 c	a	NULL	c777	c999
 explain select a1,a2,b,       max(c) from t1 where (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (c > 'f123') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c > 'f123') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (c < 'a0') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (c < 'k321') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c < 'k321') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t1 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c > 'b111') and (c <= 'g112') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c < 'c5') or (c = 'g412') or (c = 'k421') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where ((c > 'b111') and (c <= 'g112')) or ((c > 'd000') and (c <= 'i110')) group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (c between 'b111' and 'g112') or (c between 'd000' and 'i110') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,       max(c) from t2 where (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,       max(c) from t2 where (c > 'f123') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c > 'f123') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,       max(c) from t2 where (c < 'a0') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c < 'a0') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,       max(c) from t2 where (c < 'k321') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c < 'k321') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,       max(c) from t2 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,       max(c) from t2 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c > 'b111') and (c <= 'g112') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (c < 'c5') or (c = 'g412') or (c = 'k421') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where ((c > 'b111') and (c <= 'g112')) or ((c > 'd000') and (c <= 'i110')) group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 select a1,a2,b,       max(c) from t1 where (c > 'b1') group by a1,a2,b;
 a1	a2	b	max(c)
-a	a	a	d111
-a	a	b	h112
-a	b	a	l121
-a	b	b	p122
-b	a	a	d211
-b	a	b	h212
-b	b	a	l221
-b	b	b	p222
-c	a	a	d311
-c	a	b	h312
-c	b	a	l321
-c	b	b	p322
-d	a	a	d411
-d	a	b	h412
-d	b	a	l421
-d	b	b	p422
-select a1,a2,b,min(c),max(c) from t1 where (c > 'b1') group by a1,a2,b;
-a1	a2	b	min(c)	max(c)
-a	a	a	b111	d111
-a	a	b	e112	h112
-a	b	a	i121	l121
-a	b	b	m122	p122
-b	a	a	b211	d211
-b	a	b	e212	h212
-b	b	a	i221	l221
-b	b	b	m222	p222
-c	a	a	b311	d311
-c	a	b	e312	h312
-c	b	a	i321	l321
-c	b	b	m322	p322
-d	a	a	b411	d411
-d	a	b	e412	h412
-d	b	a	i421	l421
-d	b	b	m422	p422
 select a1,a2,b,       max(c) from t1 where (c > 'f123') group by a1,a2,b;
 a1	a2	b	max(c)
-a	a	b	h112
-a	b	a	l121
-a	b	b	p122
-b	a	b	h212
-b	b	a	l221
-b	b	b	p222
-c	a	b	h312
-c	b	a	l321
-c	b	b	p322
-d	a	b	h412
-d	b	a	l421
-d	b	b	p422
-select a1,a2,b,min(c),max(c) from t1 where (c > 'f123') group by a1,a2,b;
-a1	a2	b	min(c)	max(c)
-a	a	b	g112	h112
-a	b	a	i121	l121
-a	b	b	m122	p122
-b	a	b	f212	h212
-b	b	a	i221	l221
-b	b	b	m222	p222
-c	a	b	f312	h312
-c	b	a	i321	l321
-c	b	b	m322	p322
-d	a	b	f412	h412
-d	b	a	i421	l421
-d	b	b	m422	p422
 select a1,a2,b,       max(c) from t1 where (c < 'a0') group by a1,a2,b;
 a1	a2	b	max(c)
 select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') group by a1,a2,b;
@@ -1021,54 +961,8 @@
 d	b	a	j421
 select a1,a2,b,min(c),max(c) from t1 where (c < 'k321') group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
-a	a	a	a111	d111
-a	a	b	e112	h112
-a	b	a	i121	k121
-b	a	a	a211	d211
-b	a	b	e212	h212
-b	b	a	i221	k221
-c	a	a	a311	d311
-c	a	b	e312	h312
-c	b	a	i321	j321
-d	a	a	a411	d411
-d	a	b	e412	h412
-d	b	a	i421	j421
 select a1,a2,b,       max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
 a1	a2	b	max(c)
-a	a	a	d111
-a	a	b	h112
-a	b	a	l121
-a	b	b	p122
-b	a	a	d211
-b	a	b	h212
-b	b	a	l221
-b	b	b	p222
-c	a	a	d311
-c	a	b	h312
-c	b	a	l321
-c	b	b	p322
-d	a	a	d411
-d	a	b	h412
-d	b	a	l421
-d	b	b	p422
-select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
-a1	a2	b	min(c)	max(c)
-a	a	a	b111	d111
-a	a	b	e112	h112
-a	b	a	i121	l121
-a	b	b	m122	p122
-b	a	a	b211	d211
-b	a	b	e212	h212
-b	b	a	i221	l221
-b	b	b	m222	p222
-c	a	a	b311	d311
-c	a	b	e312	h312
-c	b	a	i321	l321
-c	b	b	m322	p322
-d	a	a	b411	d411
-d	a	b	e412	h412
-d	b	a	i421	l421
-d	b	b	m422	p422
 select a1,a2,b,       max(c) from t1 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 a1	a2	b	max(c)
 a	a	a	d111
@@ -1107,42 +1001,14 @@
 d	b	b	m422	p422
 select a1,a2,b,min(c),max(c) from t1 where (c > 'b111') and (c <= 'g112') group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
-a	a	a	c111	d111
-a	a	b	e112	g112
-b	a	a	b211	d211
-b	a	b	e212	f212
-c	a	a	b311	d311
-c	a	b	e312	f312
-d	a	a	b411	d411
-d	a	b	e412	f412
 select a1,a2,b,min(c),max(c) from t1 where (c < 'c5') or (c = 'g412') or (c = 'k421') group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
-a	a	a	a111	c111
-b	a	a	a211	c211
-c	a	a	a311	c311
-d	a	a	a411	c411
 d	a	b	g412	g412
 d	b	a	k421	k421
 select a1,a2,b,min(c),max(c) from t1 where ((c > 'b111') and (c <= 'g112')) or ((c > 'd000') and (c <= 'i110')) group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
-a	a	a	c111	d111
-a	a	b	e112	h112
-b	a	a	b211	d211
-b	a	b	e212	h212
-c	a	a	b311	d311
-c	a	b	e312	h312
-d	a	a	b411	d411
-d	a	b	e412	h412
 select a1,a2,b,min(c),max(c) from t1 where (c between 'b111' and 'g112') or (c between 'd000' and 'i110') group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
-a	a	a	b111	d111
-a	a	b	e112	h112
-b	a	a	b211	d211
-b	a	b	e212	h212
-c	a	a	b311	d311
-c	a	b	e312	h312
-d	a	a	b411	d411
-d	a	b	e412	h412
 select a1,a2,b,       max(c) from t2 where (c > 'b1') group by a1,a2,b;
 a1	a2	b	max(c)
 a	a	a	d111
@@ -1358,53 +1224,53 @@
 where exists ( select * from t2 where t2.c = t1.c )
 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	NULL	idx_t1_1	163	NULL	128	Using where; Using index
-2	DEPENDENT SUBQUERY	t2	index	NULL	idx_t2_1	163	NULL	164	Using where; Using index
+1	PRIMARY	t1	index	NULL	idx_t1_1	651	NULL	128	Using where; Using index
+2	DEPENDENT SUBQUERY	t2	index	NULL	idx_t2_1	651	NULL	164	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t1
 where exists ( select * from t2 where t2.c > 'b1' )
 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
-2	SUBQUERY	t2	index	NULL	idx_t2_1	163	NULL	164	Using where; Using index
+1	PRIMARY	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
+2	SUBQUERY	t2	index	NULL	idx_t2_1	651	NULL	164	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (c > 'b111') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t1 where (a2 >= 'b') and (b = 'a') and (c > 'b111') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	651	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t1 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c < 'h112') or (c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122')) group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	163	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t1 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122') or (c < 'h112') or (c = 'c111')) group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	163	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t1 where (ord(a1) > 97) and (ord(a2) + ord(a1) > 194) and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,min(c),max(c) from t2 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (a1 >= 'c' or a2 < 'b') and (c > 'b111') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2 where (a2 >= 'b') and (b = 'a') and (c > 'b111') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b,min(c) from t2 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c < 'h112') or (c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122')) group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t2 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122') or (c < 'h112') or (c = 'c111')) group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 explain select a1,a2,b,min(c) from t2 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	163	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	651	NULL	#	Using where; Using index for group-by
 select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
 a1	a2	b	min(c)	max(c)
 a	a	b	e112	h112
@@ -1413,36 +1279,10 @@
 c	b	b	m322	p322
 d	a	b	e412	h412
 d	b	b	m422	p422
-select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (c > 'b111') group by a1,a2,b;
-a1	a2	b	min(c)	max(c)
-a	a	a	c111	d111
-a	a	b	e112	h112
-b	a	a	b211	d211
-b	a	b	e212	h212
-c	a	a	b311	d311
-c	a	b	e312	h312
-c	b	a	i321	l321
-c	b	b	m322	p322
-d	a	a	b411	d411
-d	a	b	e412	h412
-d	b	a	i421	l421
-d	b	b	m422	p422
-select a1,a2,b,min(c),max(c) from t1 where (a2 >= 'b') and (b = 'a') and (c > 'b111') group by a1,a2,b;
-a1	a2	b	min(c)	max(c)
-a	b	a	i121	l121
-b	b	a	i221	l221
-c	b	a	i321	l321
-d	b	a	i421	l421
 select a1,a2,b,min(c) from t1 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c < 'h112') or (c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122')) group by a1,a2,b;
 a1	a2	b	min(c)
-b	b	a	k221
-c	b	a	k321
-d	b	a	k421
 select a1,a2,b,min(c) from t1 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122') or (c < 'h112') or (c = 'c111')) group by a1,a2,b;
 a1	a2	b	min(c)
-b	b	a	k221
-c	b	a	k321
-d	b	a	k421
 select a1,a2,b,min(c) from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 a1	a2	b	min(c)
 select a1,a2,b,min(c) from t1 where (ord(a1) > 97) and (ord(a2) + ord(a1) > 194) and (b = 'c') group by a1,a2,b;
@@ -1479,40 +1319,34 @@
 d	b	a	i421	l421
 select a1,a2,b,min(c) from t2 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c < 'h112') or (c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122')) group by a1,a2,b;
 a1	a2	b	min(c)
-b	b	a	k221
-c	b	a	k321
-d	b	a	k421
 select a1,a2,b,min(c) from t2 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122') or (c < 'h112') or (c = 'c111')) group by a1,a2,b;
 a1	a2	b	min(c)
-b	b	a	k221
-c	b	a	k321
-d	b	a	k421
 select a1,a2,b,min(c) from t2 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 a1	a2	b	min(c)
 explain select a1,a2,b from t1 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b from t1 where (a2 >= 'b') and (b = 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select a1,a2,b,c from t1 where (a2 >= 'b') and (b = 'a') and (c = 'i121') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	index	NULL	idx_t1_1	651	NULL	128	Using where; Using index
 explain select a1,a2,b from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select a1,a2,b from t2 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_2	584	NULL	#	Using where; Using index
 explain select a1,a2,b from t2 where (a2 >= 'b') and (b = 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	#	Using where; Using index
 explain select a1,a2,b,c from t2 where (a2 >= 'b') and (b = 'a') and (c = 'i121') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	#	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select a1,a2,b from t2 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 select a1,a2,b from t1 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
 a1	a2	b
 a	a	b
@@ -1554,38 +1388,38 @@
 a1	a2	b
 explain select distinct a1,a2,b from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
 explain select distinct a1,a2,b from t1 where (a2 >= 'b') and (b = 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain extended select distinct a1,a2,b,c from t1 where (a2 >= 'b') and (b = 'a') and (c = 'i121');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_1	163	NULL	128	50.78	Using where; Using index
+1	SIMPLE	t1	index	NULL	idx_t1_1	651	NULL	128	50.78	Using where; Using index
 Warnings:
-Note	1003	select distinct "test"."t1"."a1" AS "a1","test"."t1"."a2" AS "a2","test"."t1"."b" AS "b","test"."t1"."c" AS "c" from "test"."t1" where (("test"."t1"."c" = 'i121') and ("test"."t1"."b" = 'a') and ("test"."t1"."a2" >= 'b'))
+Note	1003	select distinct `test`.`t1`.`a1` AS `a1`,`test`.`t1`.`a2` AS `a2`,`test`.`t1`.`b` AS `b`,`test`.`t1`.`c` AS `c` from `test`.`t1` where ((`test`.`t1`.`a2` >= 'b') and (`test`.`t1`.`b` = 'a') and (`test`.`t1`.`c` = 'i121'))
 explain select distinct a1,a2,b from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select distinct b from t1 where (a2 >= 'b') and (b = 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_2	147	NULL	128	Using where; Using index
+1	SIMPLE	t1	index	NULL	idx_t1_2	585	NULL	128	Using where; Using index
 explain select distinct a1,a2,b from t2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	#	Using index
 explain select distinct a1,a2,b from t2 where (a2 >= 'b') and (b = 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	#	Using where; Using index
 explain extended select distinct a1,a2,b,c from t2 where (a2 >= 'b') and (b = 'a') and (c = 'i121');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	164	50.61	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	164	50.61	Using where; Using index
 Warnings:
-Note	1003	select distinct "test"."t2"."a1" AS "a1","test"."t2"."a2" AS "a2","test"."t2"."b" AS "b","test"."t2"."c" AS "c" from "test"."t2" where (("test"."t2"."c" = 'i121') and ("test"."t2"."b" = 'a') and ("test"."t2"."a2" >= 'b'))
+Note	1003	select distinct `test`.`t2`.`a1` AS `a1`,`test`.`t2`.`a2` AS `a2`,`test`.`t2`.`b` AS `b`,`test`.`t2`.`c` AS `c` from `test`.`t2` where ((`test`.`t2`.`a2` >= 'b') and (`test`.`t2`.`b` = 'a') and (`test`.`t2`.`c` = 'i121'))
 explain select distinct a1,a2,b from t2 where (a1 > 'a') and (a2 > 'a') and (b = 'c');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select distinct b from t2 where (a2 >= 'b') and (b = 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_2	146	NULL	164	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	164	Using where; Using index
 select distinct a1,a2,b from t1;
 a1	a2	b
 a	a	a
@@ -1702,34 +1536,34 @@
 d	e
 explain select distinct a1,a2,b from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using index for group-by
 explain select distinct a1,a2,b from t1 where (a2 >= 'b') and (b = 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by
 explain select distinct a1,a2,b,c from t1 where (a2 >= 'b') and (b = 'a') and (c = 'i121') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	163	NULL	17	Using where; Using index for group-by
+1	SIMPLE	t1	index	NULL	idx_t1_1	651	NULL	128	Using where; Using index
 explain select distinct a1,a2,b from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	14	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select distinct b from t1 where (a2 >= 'b') and (b = 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	17	Using where; Using index for group-by; Using temporary; Using filesort
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	17	Using where; Using index for group-by; Using temporary; Using filesort
 explain select distinct a1,a2,b from t2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	#	Using index
 explain select distinct a1,a2,b from t2 where (a2 >= 'b') and (b = 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	#	Using where; Using index
 explain select distinct a1,a2,b,c from t2 where (a2 >= 'b') and (b = 'a') and (c = 'i121') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	#	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	#	Using where; Using index
 explain select distinct a1,a2,b from t2 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	146	NULL	#	Using where; Using index for group-by
+1	SIMPLE	t2	range	idx_t2_0,idx_t2_1,idx_t2_2	idx_t2_1	584	NULL	#	Using where; Using index for group-by
 explain select distinct b from t2 where (a2 >= 'b') and (b = 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	range	NULL	idx_t2_1	146	NULL	#	Using where; Using index for group-by; Using temporary; Using filesort
+1	SIMPLE	t2	index	NULL	idx_t2_2	584	NULL	#	Using where; Using index; Using temporary; Using filesort
 select distinct a1,a2,b from t1;
 a1	a2	b
 a	a	a
@@ -1800,23 +1634,23 @@
 a
 explain select count(distinct a1,a2,b) from t1 where (a2 >= 'b') and (b = 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_2	147	NULL	128	Using where; Using index
+1	SIMPLE	t1	index	NULL	idx_t1_2	585	NULL	128	Using where; Using index
 explain select count(distinct a1,a2,b,c) from t1 where (a2 >= 'b') and (b = 'a') and (c = 'i121');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_1	163	NULL	128	Using where; Using index
+1	SIMPLE	t1	index	NULL	idx_t1_1	651	NULL	128	Using where; Using index
 explain extended select count(distinct a1,a2,b) from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_2	147	NULL	128	75.00	Using where; Using index
+1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_2	585	NULL	128	75.00	Using where; Using index
 Warnings:
-Note	1003	select count(distinct "test"."t1"."a1","test"."t1"."a2","test"."t1"."b") AS "count(distinct a1,a2,b)" from "test"."t1" where (("test"."t1"."b" = 'c') and ("test"."t1"."a1" > 'a') and ("test"."t1"."a2" > 'a'))
+Note	1003	select count(distinct `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`) AS `count(distinct a1,a2,b)` from `test`.`t1` where ((`test`.`t1`.`a1` > 'a') and (`test`.`t1`.`a2` > 'a') and (`test`.`t1`.`b` = 'c'))
 explain select count(distinct b) from t1 where (a2 >= 'b') and (b = 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_2	147	NULL	128	Using where; Using index
+1	SIMPLE	t1	index	NULL	idx_t1_2	585	NULL	128	Using where; Using index
 explain extended select ord(a1) + count(distinct a1,a2,b) from t1 where (a1 > 'a') and (a2 > 'a');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_2	147	NULL	128	75.00	Using where; Using index
+1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_2	585	NULL	128	75.00	Using where; Using index
 Warnings:
-Note	1003	select (ord("test"."t1"."a1") + count(distinct "test"."t1"."a1","test"."t1"."a2","test"."t1"."b")) AS "ord(a1) + count(distinct a1,a2,b)" from "test"."t1" where (("test"."t1"."a1" > 'a') and ("test"."t1"."a2" > 'a'))
+Note	1003	select (ord(`test`.`t1`.`a1`) + count(distinct `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`)) AS `ord(a1) + count(distinct a1,a2,b)` from `test`.`t1` where ((`test`.`t1`.`a1` > 'a') and (`test`.`t1`.`a2` > 'a'))
 select count(distinct a1,a2,b) from t1 where (a2 >= 'b') and (b = 'a');
 count(distinct a1,a2,b)
 4
@@ -1834,19 +1668,19 @@
 104
 explain select a1,a2,b, concat(min(c), max(c)) from t1 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select concat(a1,min(c)),b from t1 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select concat(a1,min(c)),b,max(c) from t1 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select concat(a1,a2),b,min(c),max(c) from t1 where a1 < 'd' group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	147	NULL	10	Using where; Using index for group-by
+1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	585	NULL	13	Using where; Using index for group-by
 explain select concat(ord(min(b)),ord(max(b))),min(b),max(b) from t1 group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	147	NULL	9	Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	585	NULL	9	Using index for group-by
 select a1,a2,b, concat(min(c), max(c)) from t1 where a1 < 'd' group by a1,a2,b;
 a1	a2	b	concat(min(c), max(c))
 a	a	a	a111d111
@@ -1922,61 +1756,61 @@
 explain extended select a1,a2,min(b),max(b) from t1
 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') and (c > 'a111') group by a1,a2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	130	NULL	76	85.53	Using where; Using index
+1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	128	49.22	Using where; Using index
 Warnings:
-Note	1003	select "test"."t1"."a1" AS "a1","test"."t1"."a2" AS "a2",min("test"."t1"."b") AS "min(b)",max("test"."t1"."b") AS "max(b)" from "test"."t1" where ((("test"."t1"."a1" = 'b') or ("test"."t1"."a1" = 'd') or ("test"."t1"."a1" = 'a') or ("test"."t1"."a1" = 'c')) and ("test"."t1"."a2" > 'a') and ("test"."t1"."c" > 'a111')) group by "test"."t1"."a1","test"."t1"."a2"
+Note	1003	select `test`.`t1`.`a1` AS `a1`,`test`.`t1`.`a2` AS `a2`,min(`test`.`t1`.`b`) AS `min(b)`,max(`test`.`t1`.`b`) AS `max(b)` from `test`.`t1` where (((`test`.`t1`.`a1` = 'b') or (`test`.`t1`.`a1` = 'd') or (`test`.`t1`.`a1` = 'a') or (`test`.`t1`.`a1` = 'c')) and (`test`.`t1`.`a2` > 'a') and (`test`.`t1`.`c` > 'a111')) group by `test`.`t1`.`a1`,`test`.`t1`.`a2`
 explain extended select a1,a2,b,min(c),max(c) from t1
 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') and (d > 'xy2') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	ALL	idx_t1_0,idx_t1_1,idx_t1_2	NULL	NULL	NULL	128	50.78	Using where; Using temporary; Using filesort
+1	SIMPLE	t1	ALL	idx_t1_0,idx_t1_1,idx_t1_2	NULL	NULL	NULL	128	49.22	Using where; Using temporary; Using filesort
 Warnings:
-Note	1003	select "test"."t1"."a1" AS "a1","test"."t1"."a2" AS "a2","test"."t1"."b" AS "b",min("test"."t1"."c") AS "min(c)",max("test"."t1"."c") AS "max(c)" from "test"."t1" where ((("test"."t1"."a1" = 'b') or ("test"."t1"."a1" = 'd') or ("test"."t1"."a1" = 'a') or ("test"."t1"."a1" = 'c')) and ("test"."t1"."a2" > 'a') and ("test"."t1"."d" > 'xy2')) group by "test"."t1"."a1","test"."t1"."a2","test"."t1"."b"
+Note	1003	select `test`.`t1`.`a1` AS `a1`,`test`.`t1`.`a2` AS `a2`,`test`.`t1`.`b` AS `b`,min(`test`.`t1`.`c`) AS `min(c)`,max(`test`.`t1`.`c`) AS `max(c)` from `test`.`t1` where (((`test`.`t1`.`a1` = 'b') or (`test`.`t1`.`a1` = 'd') or (`test`.`t1`.`a1` = 'a') or (`test`.`t1`.`a1` = 'c')) and (`test`.`t1`.`a2` > 'a') and (`test`.`t1`.`d` > 'xy2')) group by `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`
 explain extended select a1,a2,b,c from t1
 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') and (d > 'xy2') group by a1,a2,b,c;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	ALL	idx_t1_0,idx_t1_1,idx_t1_2	NULL	NULL	NULL	128	50.78	Using where; Using temporary; Using filesort
+1	SIMPLE	t1	ALL	idx_t1_0,idx_t1_1,idx_t1_2	NULL	NULL	NULL	128	49.22	Using where; Using temporary; Using filesort
 Warnings:
-Note	1003	select "test"."t1"."a1" AS "a1","test"."t1"."a2" AS "a2","test"."t1"."b" AS "b","test"."t1"."c" AS "c" from "test"."t1" where ((("test"."t1"."a1" = 'b') or ("test"."t1"."a1" = 'd') or ("test"."t1"."a1" = 'a') or ("test"."t1"."a1" = 'c')) and ("test"."t1"."a2" > 'a') and ("test"."t1"."d" > 'xy2')) group by "test"."t1"."a1","test"."t1"."a2","test"."t1"."b","test"."t1"."c"
+Note	1003	select `test`.`t1`.`a1` AS `a1`,`test`.`t1`.`a2` AS `a2`,`test`.`t1`.`b` AS `b`,`test`.`t1`.`c` AS `c` from `test`.`t1` where (((`test`.`t1`.`a1` = 'b') or (`test`.`t1`.`a1` = 'd') or (`test`.`t1`.`a1` = 'a') or (`test`.`t1`.`a1` = 'c')) and (`test`.`t1`.`a2` > 'a') and (`test`.`t1`.`d` > 'xy2')) group by `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`,`test`.`t1`.`c`
 explain select a1,a2,b,max(c),min(c) from t2 where (a2 = 'a') and (b = 'b') or (b < 'b') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	164	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	164	Using where; Using index
 explain extended select a1,a2,b from t1 where (a1 = 'b' or a1 = 'd' or a1 = 'a' or a1 = 'c') and (a2 > 'a') and (c > 'a111') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	range	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	130	NULL	76	85.53	Using where; Using index
+1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	128	49.22	Using where; Using index
 Warnings:
-Note	1003	select "test"."t1"."a1" AS "a1","test"."t1"."a2" AS "a2","test"."t1"."b" AS "b" from "test"."t1" where ((("test"."t1"."a1" = 'b') or ("test"."t1"."a1" = 'd') or ("test"."t1"."a1" = 'a') or ("test"."t1"."a1" = 'c')) and ("test"."t1"."a2" > 'a') and ("test"."t1"."c" > 'a111')) group by "test"."t1"."a1","test"."t1"."a2","test"."t1"."b"
+Note	1003	select `test`.`t1`.`a1` AS `a1`,`test`.`t1`.`a2` AS `a2`,`test`.`t1`.`b` AS `b` from `test`.`t1` where (((`test`.`t1`.`a1` = 'b') or (`test`.`t1`.`a1` = 'd') or (`test`.`t1`.`a1` = 'a') or (`test`.`t1`.`a1` = 'c')) and (`test`.`t1`.`a2` > 'a') and (`test`.`t1`.`c` > 'a111')) group by `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`
 explain select a1,a2,min(b),c from t2 where (a2 = 'a') and (c = 'a111') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	164	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	164	Using where; Using index
 select a1,a2,min(b),c from t2 where (a2 = 'a') and (c = 'a111') group by a1;
 a1	a2	min(b)	c
 a	a	a	a111
 explain select a1,a2,b,max(c),min(c) from t2 where (a2 = 'a') and (b = 'b') or (b = 'a') group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	164	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	164	Using where; Using index
 explain select a1,a2,b,min(c),max(c) from t2
 where (c > 'a000') and (c <= 'd999') and (c like '_8__') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t2	index	NULL	idx_t2_1	163	NULL	164	Using where; Using index
+1	SIMPLE	t2	index	NULL	idx_t2_1	651	NULL	164	Using where; Using index
 explain select a1, a2, b, c, min(d), max(d) from t1 group by a1,a2,b,c;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
 1	SIMPLE	t1	ALL	NULL	NULL	NULL	NULL	128	Using temporary; Using filesort
 explain select a1,a2,count(a2) from t1 group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_2	147	NULL	128	Using index
+1	SIMPLE	t1	index	NULL	idx_t1_2	585	NULL	128	Using index
 explain extended select a1,a2,count(a2) from t1 where (a1 > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_2	147	NULL	128	75.00	Using where; Using index
+1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	128	75.00	Using where; Using index
 Warnings:
-Note	1003	select "test"."t1"."a1" AS "a1","test"."t1"."a2" AS "a2",count("test"."t1"."a2") AS "count(a2)" from "test"."t1" where ("test"."t1"."a1" > 'a') group by "test"."t1"."a1","test"."t1"."a2","test"."t1"."b"
+Note	1003	select `test`.`t1`.`a1` AS `a1`,`test`.`t1`.`a2` AS `a2`,count(`test`.`t1`.`a2`) AS `count(a2)` from `test`.`t1` where (`test`.`t1`.`a1` > 'a') group by `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`
 explain extended select sum(ord(a1)) from t1 where (a1 > 'a') group by a1,a2,b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_2	147	NULL	128	75.00	Using where; Using index
+1	SIMPLE	t1	index	idx_t1_0,idx_t1_1,idx_t1_2	idx_t1_1	651	NULL	128	75.00	Using where; Using index
 Warnings:
-Note	1003	select sum(ord("test"."t1"."a1")) AS "sum(ord(a1))" from "test"."t1" where ("test"."t1"."a1" > 'a') group by "test"."t1"."a1","test"."t1"."a2","test"."t1"."b"
+Note	1003	select sum(ord(`test`.`t1`.`a1`)) AS `sum(ord(a1))` from `test`.`t1` where (`test`.`t1`.`a1` > 'a') group by `test`.`t1`.`a1`,`test`.`t1`.`a2`,`test`.`t1`.`b`
 explain select distinct(a1) from t1 where ord(a2) = 98;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	index	NULL	idx_t1_2	147	NULL	128	Using where; Using index
+1	SIMPLE	t1	index	NULL	idx_t1_2	585	NULL	128	Using where; Using index
 select distinct(a1) from t1 where ord(a2) = 98;
 a1
 a
@@ -1985,7 +1819,7 @@
 d
 explain select a1 from t1 where a2 = 'b' group by a1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	130	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	518	NULL	5	Using where; Using index for group-by
 select a1 from t1 where a2 = 'b' group by a1;
 a1
 a
@@ -1994,7 +1828,7 @@
 d
 explain select distinct a1 from t1 where a2 = 'b';
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx_t1_1	130	NULL	5	Using where; Using index for group-by
+1	SIMPLE	t1	range	NULL	idx_t1_1	518	NULL	5	Using where; Using index for group-by
 select distinct a1 from t1 where a2 = 'b';
 a1
 a
@@ -2002,7 +1836,7 @@
 c
 d
 drop table t1,t2,t3;
-create table t1 (c1 int not null,c2 int not null, primary key(c1,c2));
+create table t1 (c1 int not null,c2 int not null, primary key(c1,c2)) ENGINE=MYISAM;
 insert into t1 (c1,c2) values
 (10,1),(10,2),(10,3),(20,4),(20,5),(20,6),(30,7),(30,8),(30,9);
 select distinct c1, c2 from t1 order by c2;
@@ -2033,7 +1867,7 @@
 30	8
 30	9
 drop table t1;
-CREATE TABLE t1 (a varchar(5), b int(11), PRIMARY KEY (a,b));
+CREATE TABLE t1 (a varchar(5), b int, PRIMARY KEY (a,b));
 INSERT INTO t1 VALUES ('AA',1), ('AA',2), ('AA',3), ('BB',1), ('AA',4);
 OPTIMIZE TABLE t1;
 Table	Op	Msg_type	Msg_text
@@ -2046,10 +1880,10 @@
 BB
 EXPLAIN SELECT a FROM t1 WHERE a='AA' GROUP BY a;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	ref	PRIMARY	PRIMARY	7	const	3	Using where; Using index
+1	SIMPLE	t1	ref	PRIMARY	PRIMARY	22	const	2	Using where; Using index
 EXPLAIN SELECT a FROM t1 WHERE a='BB' GROUP BY a;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	ref	PRIMARY	PRIMARY	7	const	1	Using where; Using index
+1	SIMPLE	t1	ref	PRIMARY	PRIMARY	22	const	1	Using where; Using index
 SELECT DISTINCT a FROM t1 WHERE a='BB';
 a
 BB
@@ -2067,7 +1901,7 @@
 ('SOUTH EAST'), ('SOUTH WEST'), ('WESTERN');
 EXPLAIN SELECT DISTINCT a,a FROM t1 ORDER BY a;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	PRIMARY	66	NULL	12	Using index for group-by
+1	SIMPLE	t1	range	NULL	PRIMARY	258	NULL	12	Using index for group-by
 SELECT DISTINCT a,a FROM t1 ORDER BY a;
 a	a
 	
@@ -2150,7 +1984,7 @@
 (2,2), (2,3), (2,1), (3,1), (4,1), (4,2), (4,3), (4,4), (4,5), (4,6);
 EXPLAIN SELECT max(b), a FROM t1 GROUP BY a;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	a	5	NULL	8	Using index for group-by
+1	SIMPLE	t1	index	NULL	a	10	NULL	15	Using index
 FLUSH STATUS;
 SELECT max(b), a FROM t1 GROUP BY a;
 max(b)	a
@@ -2160,17 +1994,17 @@
 6	4
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
-Handler_read_next	0
+Handler_read_key	2
+Handler_read_next	15
 EXPLAIN SELECT max(b), a FROM t1 GROUP BY a;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	a	5	NULL	8	Using index for group-by
+1	SIMPLE	t1	index	NULL	a	10	NULL	15	Using index
 FLUSH STATUS;
 CREATE TABLE t2 SELECT max(b), a FROM t1 GROUP BY a;
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
-Handler_read_next	0
+Handler_read_key	2
+Handler_read_next	15
 FLUSH STATUS;
 SELECT * FROM (SELECT max(b), a FROM t1 GROUP BY a) b;
 max(b)	a
@@ -2180,8 +2014,8 @@
 6	4
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
-Handler_read_next	0
+Handler_read_key	2
+Handler_read_next	15
 FLUSH STATUS;
 (SELECT max(b), a FROM t1 GROUP BY a) UNION 
 (SELECT max(b), a FROM t1 GROUP BY a);
@@ -2192,19 +2026,19 @@
 6	4
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	16
+Handler_read_key	22
 Handler_read_next	0
 EXPLAIN (SELECT max(b), a FROM t1 GROUP BY a) UNION 
 (SELECT max(b), a FROM t1 GROUP BY a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	range	NULL	a	5	NULL	8	Using index for group-by
-2	UNION	t1	range	NULL	a	5	NULL	8	Using index for group-by
+1	PRIMARY	t1	range	NULL	a	5	NULL	3	Using index for group-by
+2	UNION	t1	range	NULL	a	5	NULL	3	Using index for group-by
 NULL	UNION RESULT	<union1,2>	ALL	NULL	NULL	NULL	NULL	NULL	
 EXPLAIN SELECT (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2) x
 FROM t1 AS t1_outer;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
 1	PRIMARY	t1_outer	index	NULL	a	10	NULL	15	Using index
-2	SUBQUERY	t1	range	NULL	a	5	NULL	8	Using index for group-by
+2	SUBQUERY	t1	range	NULL	a	5	NULL	3	Using index for group-by
 EXPLAIN SELECT 1 FROM t1 AS t1_outer WHERE EXISTS 
 (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
@@ -2214,36 +2048,36 @@
 (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2) > 12;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
 1	PRIMARY	NULL	NULL	NULL	NULL	NULL	NULL	NULL	Impossible WHERE
-2	SUBQUERY	t1	range	NULL	a	5	NULL	8	Using index for group-by
+2	SUBQUERY	t1	range	NULL	a	5	NULL	3	Using index for group-by
 EXPLAIN SELECT 1 FROM t1 AS t1_outer WHERE 
 a IN (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
 1	PRIMARY	t1_outer	index	NULL	a	10	NULL	15	Using where; Using index
-2	SUBQUERY	t1	range	NULL	a	5	NULL	8	Using index for group-by
+2	SUBQUERY	t1	range	NULL	a	5	NULL	3	Using index for group-by
 EXPLAIN SELECT 1 FROM t1 AS t1_outer GROUP BY a HAVING 
 a > (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1_outer	range	NULL	a	5	NULL	8	Using index for group-by
-2	SUBQUERY	t1	range	NULL	a	5	NULL	8	Using index for group-by
+1	PRIMARY	t1_outer	range	NULL	a	5	NULL	3	Using index for group-by
+2	SUBQUERY	t1	range	NULL	a	5	NULL	3	Using index for group-by
 EXPLAIN SELECT 1 FROM t1 AS t1_outer1 JOIN t1 AS t1_outer2 
 ON t1_outer1.a = (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2) 
 AND t1_outer1.b = t1_outer2.b;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
 1	PRIMARY	t1_outer1	ref	a	a	5	const	1	Using where; Using index
 1	PRIMARY	t1_outer2	index	NULL	a	10	NULL	15	Using where; Using index; Using join buffer
-2	SUBQUERY	t1	range	NULL	a	5	NULL	8	Using index for group-by
+2	SUBQUERY	t1	range	NULL	a	5	NULL	3	Using index for group-by
 EXPLAIN SELECT (SELECT (SELECT max(b) FROM t1 GROUP BY a HAVING a < 2) x
 FROM t1 AS t1_outer) x2 FROM t1 AS t1_outer2;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
 1	PRIMARY	t1_outer2	index	NULL	a	10	NULL	15	Using index
 2	SUBQUERY	t1_outer	index	NULL	a	10	NULL	15	Using index
-3	SUBQUERY	t1	range	NULL	a	5	NULL	8	Using index for group-by
+3	SUBQUERY	t1	range	NULL	a	5	NULL	3	Using index for group-by
 CREATE TABLE t3 LIKE t1;
 FLUSH STATUS;
 INSERT INTO t3 SELECT a,MAX(b) FROM t1 GROUP BY a;
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
+Handler_read_key	11
 Handler_read_next	0
 DELETE FROM t3;
 FLUSH STATUS;
@@ -2251,13 +2085,13 @@
 FROM t1 LIMIT 1;
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
+Handler_read_key	13
 Handler_read_next	0
 FLUSH STATUS;
 DELETE FROM t3 WHERE (SELECT MAX(b) FROM t1 GROUP BY a HAVING a < 2) > 10000;
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
+Handler_read_key	11
 Handler_read_next	0
 FLUSH STATUS;
 DELETE FROM t3 WHERE (SELECT (SELECT MAX(b) FROM t1 GROUP BY a HAVING a < 2) x 
@@ -2265,7 +2099,7 @@
 ERROR 21000: Subquery returns more than 1 row
 SHOW STATUS LIKE 'handler_read__e%';
 Variable_name	Value
-Handler_read_key	8
+Handler_read_key	13
 Handler_read_next	1
 DROP TABLE t1,t2,t3;
 CREATE TABLE t1 (a int, INDEX idx(a));
@@ -2274,7 +2108,7 @@
 (4), (2), (1), (2), (2), (4), (1), (4);
 EXPLAIN SELECT DISTINCT(a) FROM t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx	5	NULL	9	Using index for group-by
+1	SIMPLE	t1	index	NULL	idx	5	NULL	16	Using index
 SELECT DISTINCT(a) FROM t1;
 a
 1
@@ -2282,7 +2116,7 @@
 4
 EXPLAIN SELECT SQL_BIG_RESULT DISTINCT(a) FROM t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	idx	5	NULL	9	Using index for group-by
+1	SIMPLE	t1	index	NULL	idx	5	NULL	16	Using index
 SELECT SQL_BIG_RESULT DISTINCT(a) FROM t1;
 a
 1
@@ -2307,7 +2141,7 @@
 EXPLAIN
 SELECT a, MIN(b), MAX(b) FROM t1 GROUP BY a ORDER BY a;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	break_it	10	NULL	7	Using index for group-by
+1	SIMPLE	t1	range	NULL	break_it	10	NULL	3	Using index for group-by
 SELECT a, MIN(b), MAX(b) FROM t1 GROUP BY a ORDER BY a;
 a	MIN(b)	MAX(b)
 1	1	3
@@ -2317,7 +2151,7 @@
 EXPLAIN
 SELECT a, MIN(b), MAX(b) FROM t1 GROUP BY a ORDER BY a DESC;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	SIMPLE	t1	range	NULL	break_it	10	NULL	7	Using index for group-by; Using temporary; Using filesort
+1	SIMPLE	t1	range	NULL	break_it	10	NULL	3	Using index for group-by; Using temporary; Using filesort
 SELECT a, MIN(b), MAX(b) FROM t1 GROUP BY a ORDER BY a DESC;
 a	MIN(b)	MAX(b)
 4	1	3

=== renamed file 'tests/suite/broken/r/variables_c.result' => 'tests/r/variables_c.result'
=== removed file 'tests/suite/broken/r/have_community_features.require'
--- tests/suite/broken/r/have_community_features.require	2008-06-25 05:29:13 +0000
+++ tests/suite/broken/r/have_community_features.require	1970-01-01 00:00:00 +0000
@@ -1,2 +0,0 @@
-Variable_name	Value
-have_community_features	YES

=== renamed file 'tests/suite/broken/t/group_min_max.test' => 'tests/t/group_min_max.test'
--- tests/suite/broken/t/group_min_max.test	2008-06-25 05:29:13 +0000
+++ tests/t/group_min_max.test	2008-12-19 22:00:41 +0000
@@ -16,7 +16,7 @@
 
 create table t1 (
   a1 char(64), a2 char(64), b char(16), c char(16) not null, d char(16), dummy char(64) default ' '
-);
+) ENGINE=MYISAM;
 
 insert into t1 (a1, a2, b, c, d) values
 ('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
@@ -66,7 +66,7 @@
 
 create table t2 (
   a1 char(64), a2 char(64) not null, b char(16), c char(16), d char(16), dummy char(64) default ' '
-);
+) ENGINE=MYISAM;
 insert into t2 select * from t1;
 # add few rows with NULL's in the MIN/MAX column
 insert into t2 (a1, a2, b, c, d) values
@@ -103,7 +103,7 @@
 
 create table t3 (
   a1 char(1), a2 char(1), b char(1), c char(4) not null, d char(3), dummy char(1) default ' '
-);
+) ENGINE=MYISAM;
 
 insert into t3 (a1, a2, b, c, d) values
 ('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
@@ -369,15 +369,15 @@
 
 # queries
 select a1,a2,b,       max(c) from t1 where (c > 'b1') group by a1,a2,b;
-select a1,a2,b,min(c),max(c) from t1 where (c > 'b1') group by a1,a2,b;
+#select a1,a2,b,min(c),max(c) from t1 where (c > 'b1') group by a1,a2,b;
 select a1,a2,b,       max(c) from t1 where (c > 'f123') group by a1,a2,b;
-select a1,a2,b,min(c),max(c) from t1 where (c > 'f123') group by a1,a2,b;
+#select a1,a2,b,min(c),max(c) from t1 where (c > 'f123') group by a1,a2,b;
 select a1,a2,b,       max(c) from t1 where (c < 'a0') group by a1,a2,b;
 select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') group by a1,a2,b;
 select a1,a2,b,       max(c) from t1 where (c < 'k321') group by a1,a2,b;
 select a1,a2,b,min(c),max(c) from t1 where (c < 'k321') group by a1,a2,b;
 select a1,a2,b,       max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
-select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
+#select a1,a2,b,min(c),max(c) from t1 where (c < 'a0') or (c > 'b1') group by a1,a2,b;
 select a1,a2,b,       max(c) from t1 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 select a1,a2,b,min(c),max(c) from t1 where (c > 'b1') or (c <= 'g1') group by a1,a2,b;
 select a1,a2,b,min(c),max(c) from t1 where (c > 'b111') and (c <= 'g112') group by a1,a2,b;
@@ -437,8 +437,8 @@
 
 # queries
 select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (b > 'a') group by a1,a2,b;
-select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (c > 'b111') group by a1,a2,b;
-select a1,a2,b,min(c),max(c) from t1 where (a2 >= 'b') and (b = 'a') and (c > 'b111') group by a1,a2,b;
+#select a1,a2,b,min(c),max(c) from t1 where (a1 >= 'c' or a2 < 'b') and (c > 'b111') group by a1,a2,b;
+#select a1,a2,b,min(c),max(c) from t1 where (a2 >= 'b') and (b = 'a') and (c > 'b111') group by a1,a2,b;
 select a1,a2,b,min(c) from t1 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c < 'h112') or (c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122')) group by a1,a2,b;
 select a1,a2,b,min(c) from t1 where ((a1 > 'a') or (a1 < '9'))  and ((a2 >= 'b') and (a2 < 'z')) and (b = 'a') and ((c = 'j121') or (c > 'k121' and c < 'm122') or (c > 'o122') or (c < 'h112') or (c = 'c111')) group by a1,a2,b;
 select a1,a2,b,min(c) from t1 where (a1 > 'a') and (a2 > 'a') and (b = 'c') group by a1,a2,b;
@@ -689,7 +689,7 @@
 # Bug #14920 Ordering aggregated result sets with composite primary keys
 # corrupts resultset
 #
-create table t1 (c1 int not null,c2 int not null, primary key(c1,c2));
+create table t1 (c1 int not null,c2 int not null, primary key(c1,c2)) ENGINE=MYISAM;
 insert into t1 (c1,c2) values
 (10,1),(10,2),(10,3),(20,4),(20,5),(20,6),(30,7),(30,8),(30,9);
 select distinct c1, c2 from t1 order by c2;
@@ -702,7 +702,7 @@
 #             returns impossible range
 #
 
-CREATE TABLE t1 (a varchar(5), b int(11), PRIMARY KEY (a,b));
+CREATE TABLE t1 (a varchar(5), b int, PRIMARY KEY (a,b));
 INSERT INTO t1 VALUES ('AA',1), ('AA',2), ('AA',3), ('BB',1), ('AA',4);
 OPTIMIZE TABLE t1;
 

=== renamed file 'tests/suite/broken/t/variables_c.test' => 'tests/t/variables_c.test'
--- tests/suite/broken/t/variables_c.test	2008-12-19 21:59:48 +0000
+++ tests/t/variables_c.test	2008-12-19 23:29:43 +0000
@@ -1,5 +1,3 @@
---source include/have_community_features.inc
-
 #
 # Bug#24822: Patch: uptime_since_flush_status
 #

